using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Shared;

namespace Server
{
	/// <summary>
	/// This class is instantiated when the user makes a request to display 
	/// the results of the election. Display Server passes all the required 
	/// information to the constructor. 
	/// </summary>
	public class DisplayResults : System.Windows.Forms.Form
	{
		private System.Windows.Forms.DataGrid dataGrid1;
		private System.Windows.Forms.Button button1;
		private ArrayList table;
		private string title, winner, label;
		private int nVotes;
		private System.Windows.Forms.Label label1;
		
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		/// <summary>
		/// Constructor
		/// </summary>
		/// <param name="table">Contains the information about the candidates 
		/// and number of votes casted for them</param>
		/// <param name="title">Name of the election</param>
		/// <param name="winner">Winner(s) name(s)</param>
		/// <param name="nVotes">Number of votes casted for the winner</param>
		public DisplayResults(ArrayList table, string title, string winner, int nVotes)
		{
			this.table = table;
			this.title = title;
			this.winner = winner;
			this.nVotes = nVotes;
			this.label = "There is no winner for this election";
			//check to see if there is a winner. No candidate can the 
			//election with 0 votes
			if(winner!=null)
				this.label= "The winner is " + winner + " with  " + nVotes + " votes";
			
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		private void InitializeComponent()
		{
			this.dataGrid1 = new System.Windows.Forms.DataGrid();
			this.button1 = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// dataGrid1
			// 
			this.dataGrid1.DataMember = "";
			this.dataGrid1.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.dataGrid1.Location = new System.Drawing.Point(0, 32);
			this.dataGrid1.Name = "dataGrid1";
			this.dataGrid1.Size = new System.Drawing.Size(296, 200);
			this.dataGrid1.TabIndex = 0;
			this.dataGrid1.DataSource = this.table;
			
			// Close Button
			// 
			this.button1.Location = new System.Drawing.Point(112, 240);
			this.button1.Name = "button1";
			this.button1.TabIndex = 1;
			this.button1.Text = "Close";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// label
			// 
			this.label1.Location = new System.Drawing.Point(16, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(256, 23);
			this.label1.TabIndex = 2;
			this.label1.Text = this.label;
			
			// 
			// DisplayResults
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 266);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.label1,
																		  this.button1,
																		  this.dataGrid1});
			this.Name = "DisplayResults";
			this.Text = "Election results for: " + this.title;
			((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion
	

		private void button1_Click(object sender, System.EventArgs e)
		{
			this.Dispose();
		}
	}
}
